﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Infragistics.Olap.FlatData;

namespace DynamicMeasuresInPivotGrid
{
    public class MyDataSource : FlatDataSource
    {
        public MyDataSource()
        {
            var flatDataConnectionSettings = new FlatDataConnectionSettings();
            ConnectionSettings = flatDataConnectionSettings;

            DimensionsGenerationMode = DimensionsGenerationMode.Mixed;
            PreserveMembersOrder = false;

            Cube = GenerateInitialCube("MyViewModel");
            Measures = GenerateInitialItems("UsualMeasure");

            CubeMetadata cubeMetadata = new CubeMetadata
            {
                DisplayName = "My model",
                DataTypeFullName = "DynamicMeasuresInPivotGrid.MyViewModel",
            };

            CubesSettings.Add(cubeMetadata);
            AddCustomMeasureMetadata();

        }

        public void AddCustomMeasureMetadata()
        {
            IList<string> measureTypes = new List<string>(new[]
            {
                "Measure1", "Measure2"
            });

            foreach (var measureType in measureTypes)
            {
                CubesSettings[0].DimensionSettings.Add(new DimensionMetadata
                {
                    DimensionType = DimensionType.Measure,
                    SourcePropertyName = measureType,
                });
            }
        }
    }
}
